﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Configuration;
using System.Data;

namespace URLRewrittingExample.Blogs
{
    public class BlogDAL
    {
        public static SqlConnection DatabaseConnection()
        {          
            string connectionString = ConfigurationManager.ConnectionStrings["DbConnectionString"].ConnectionString;
            SqlConnection con = new SqlConnection(connectionString);           
                if (con.State == ConnectionState.Closed)
                {
                    con.Open();
                }
                return con;            
        }

        public int BlogInsert(Blog objBlog)
        {
            using (SqlCommand cmd = new SqlCommand("proc_BlogInsert", DatabaseConnection()))
            {
                using (SqlDataAdapter dap = new SqlDataAdapter(cmd))
                {
                    dap.InsertCommand = cmd;
                    dap.InsertCommand.CommandType = CommandType.StoredProcedure;
                    dap.InsertCommand.Parameters.AddWithValue("@title", objBlog.Title);
                    dap.InsertCommand.Parameters.AddWithValue("@content", objBlog.Content);
                    return dap.InsertCommand.ExecuteNonQuery();
                }
            }
            
        }

        public List<Blog> GetAllBlogs()
        {
            List<Blog> blogsList = new List<Blog>();            
            SqlCommand cmd = new SqlCommand("Select Id,Title,Visit from Blog", DatabaseConnection());
            IDataReader dr = cmd.ExecuteReader();
            while (dr.Read())
            {
                blogsList.Add(new Blog(Convert.ToInt32(dr["Id"].ToString()),dr["Title"].ToString(),
                                            Convert.ToInt32(dr["Visit"].ToString())));
            }
            dr.Close();
            return blogsList;
        }

        public Blog GetBlogById(int id)
        {
            Blog objBlog = null;
            SqlCommand cmd = new SqlCommand("Select Title,Visit,Content from Blog where Id="+id, DatabaseConnection());
            IDataReader dr = cmd.ExecuteReader();
            while(dr.Read())
            {               
             objBlog = new Blog(id,
                                dr["Title"].ToString(),
                                Convert.ToInt32(dr["Visit"].ToString()),
                                dr["Content"].ToString());
            }
            dr.Close();
            return objBlog;
        }

        public int BlogVisitorIncrement(int id)
        {
            using (SqlCommand cmd = new SqlCommand("proc_VisitorIncrement", DatabaseConnection()))
            {
                cmd.CommandType = CommandType.StoredProcedure;
                using (SqlDataAdapter adapter = new SqlDataAdapter(cmd))
                {
                    adapter.UpdateCommand = cmd;                    
                    SqlParameter param = new SqlParameter("@id",id);
                    adapter.UpdateCommand.Parameters.Add(param);                                     
                    return adapter.UpdateCommand.ExecuteNonQuery();
                }
            }
        }
    }
}