﻿using System;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace URLRewrittingExample.Blogs
{
    public partial class BlogList : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                ShowBlogList();
            }
        }
        private void ShowBlogList()
        {
            BlogDAL objBlogDAL = new BlogDAL();
            rptBlog.DataSource = objBlogDAL.GetAllBlogs();
            rptBlog.DataBind();
        }

        protected void rptBlog_ItemDataBound(object sender, RepeaterItemEventArgs e)
        {
            if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
            {
                LinkButton lnkTitle = (LinkButton) e.Item.FindControl("lnkTitle");
                lnkTitle.Style.Add("text-decoration", "none");
                Blog Item =(Blog) e.Item.DataItem;
                lnkTitle.PostBackUrl = GenerateURL(Item.Title, Item.Id);
            }
        }

        public static string GenerateURL(string title, int Id)
        {
            string strTitle = title.Trim();
            strTitle = strTitle.ToLower();           
            strTitle = strTitle.Replace("c#", "C-Sharp");
            strTitle = strTitle.Replace(" ", "-");
            strTitle = strTitle.Trim();           
            strTitle = strTitle.Trim('-');
            strTitle = "~/Blogs/"+strTitle+"-"+Id.ToString() + ".aspx";

            return strTitle;
        }
    }
}